/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            mov_encoder_writer.h
 *
 *  Sun May 22 12:51:35 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAV_MOV_ENCODER_WRITER_H__
#define __MIAV_MOV_ENCODER_WRITER_H__

#include "frame.h"
#include "thread.h"
#include "file.h"
#include "info.h"

#include <string>
using namespace std;

#define AUDIO_FRAME(x) x->number%2==1
#define VIDEO_FRAME(x) x->number%2==0

class MovEncoderWriter : public Thread {
public:
  MovEncoderWriter(const char* cpr,
                   FramePriorityQueue *video_queue, pthread_mutex_t *video_mutex, sem_t *video_sem, 
                   FramePriorityQueue *audio_queue, pthread_mutex_t *audio_mutex, sem_t *audio_sem, 
                   Info *info);
  ~MovEncoderWriter();

  void thread_main();

  volatile bool running;

private:
  Info *info;

  File *file;

  FramePriorityQueue *video_queue;
  FramePriorityQueue *audio_queue;
  pthread_mutex_t *video_mutex;
  pthread_mutex_t *audio_mutex;
  sem_t *video_sem;
  sem_t *audio_sem;

  unsigned int video_frame_number;
  unsigned int audio_frame_number;

  //  Timecode_struc SCR;
  //  double timestamp;

//  void write_audio_header(unsigned short int packetsize);
//  void write_video_header(unsigned short int packetsize);
//  void write_system_header(unsigned int audio_size, unsigned int video_size);
//  void write_packet_header(unsigned int audio_size, unsigned int video_size);
};


#endif/*__MIAV_MOV_ENCODER_WRITER_H__*/
