/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            videowidget.cc
 *
 *  Fri Sep  3 14:36:37 2004
 *  Copyright  2004  Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include <config.h>

#ifdef USE_GUI
 
#include "videowidget.h"

#include "miav_config.h"

VideoWidget::VideoWidget(QWidget *p, Camera *c, QWidget* old) : QWidget(p, "")
{
  camera = c;
  parent = p;

  oldWindow = old;

  // A welltested hack to force SDL to draw in the QWidget
  QString ids;
  setenv("SDL_WINDOWID", ids.setNum(winId()), 1);
}

VideoWidget::~VideoWidget()
{
}

QPixmap VideoWidget::getScreenshot()
{ 
  return QPixmap::grabWindow (winId());
}

static VideoWidget *fs = NULL;

void VideoWidget::mouseReleaseEvent(QMouseEvent *event)
{
  if(!parent) {    // We are a fullscreen window
    QString ids;
    setenv("SDL_WINDOWID", ids.setNum(oldWindow->winId()), 1);
    camera->resize(oldWindow->width(), oldWindow->height());
    destroy();
  } else {         // We are a nested window
    // first delete old instance (if any)
    if(fs) delete fs;
    fs = new VideoWidget(NULL, camera, this);
    fs->showFullScreen();
    fs->setFixedWidth(config->readInt("pixel_width"));
    fs->setFixedHeight(config->readInt("pixel_height"));
    camera->resize(fs->width(), fs->height());
  }
}

#endif /* USE_GUI */
